/*
****************************************************************************
****************************************************************************
**                                                                        **
**                                                                        **
**                XXXX     X    X         X XXXXXX X                      **
**               X    X   X X   X    X    X X      X   X                  **
**               X       X   X  X   X X   X X      X  X                   **
**               X   XX XXXXXXX X  X   X  X XXXX   X X                    **
**               X    X X     X X X     X X X      XX                     **
**               X    X X     X XX       XX X      X                      **
**                XXXX  X     X X         X XXXXXX XXXXXX                 **
**                                                                        **
**                           BIAYSTOK 2014                               **
**                                                                        **
**                         Home Control System                            **
**                                                                        **
**                              HC_PWC2                                   **
**                      Wersja z dnia : 2017.12.09                        **
**                     Napisal : Andrzej Pawluczuk                        **
**                                                                        **
****************************************************************************
****************************************************************************
*/


#ifndef _PWC2EEPROM_
#define _PWC2EEPROM_

#include <inttypes.h>

#define _KeyStandard_

#define StandardSygnature              0xA55A
#define EEBlockAddressOffset           4

#define DeviceIDSize                   8
typedef uint8_t DeviceIDType [ DeviceIDSize + 1 ] ;


#define CommandBufferSize              16
typedef uint8_t CommandBufferType [ CommandBufferSize + 1 ] ;


#define ParamBufferSize                32
typedef uint8_t ParamBufferType [ ParamBufferSize + 1 ] ;

typedef struct {
                 CommandBufferType CommandText ;
                 uint8_t           ParamValue ;
               } KeyCommDescrRecT ;
typedef KeyCommDescrRecT * PtrKeyCommDescrRecT ;

typedef struct {
                 KeyCommDescrRecT CommDescr ;
                 uint8_t          CommKey ;
               } KeyCommParamRecT ;

#define PasswordSize                   6

typedef uint8_t PasswordType [ PasswordSize + 1 ] ;

#define EventDestinDeviceArraySize     4

typedef struct {
                 uint16_t          EEBlockMetric ;
                 DeviceIDType      MyDeviceID ;
                 PasswordType      Password ;
                 DeviceIDType      EventDestinDeviceID [ EventDestinDeviceArraySize ] ;
                 KeyCommDescrRecT  StandardKeySerrvice ;
                 KeyCommDescrRecT  LongKeyService ;
                 uint16_t          CRCValue ;
               } EEPROMBlockDataRecT ;

extern EEPROMBlockDataRecT EEBlock ;
extern uint8_t ChOnCommand [ ] ;
extern uint8_t ChOffCommand [ ] ;
extern uint8_t ChInvCommand [ ] ;
extern uint8_t ChPulseOnCommand [ ] ;
extern uint8_t ChPulseOffCommand [ ] ;
extern uint8_t ChLongPulseOnCommand [ ] ;
extern uint8_t ChLongPulseOffCommand [ ] ;

void SetDefaultEEBlock ( void ) ;

#endif
